=== debian/changelog ===
electron-23 (23.3.11-1) UNRELEASED; urgency=medium

  * Initial release.

 -- Eric Long <i@hack3r.moe>  Wed, 02 Aug 2023 17:32:32 +0800
